@startuml

title 2b orderActivity
actor Actor
participant "CatERingAppManager.sheetManager:SheetManager" as sm
participant "currentSheet.activities:List<Activity>" as al
participant "r:SheetEventReceiver" as r

Actor -> sm++: orderActivity(activity, position)

alt currentSheet == null ||\n !currentSheet.hasActivity(activity)
  sm -->> Actor: throw UseCaseLogicException
else position < 0 || \n position >= activities.size()
  /'	Non so se \'e giusto.
  '/
  sm -->> Actor:throw IndexOutOfBoundsException	
else

  sm -> al++:indexOf(activity)
  sm <<-- al--: oldPosition

  sm -> al++:remove(activity)
  deactivate al

  sm -> al++:add(position, activity)
  deactivate al

  group for each r in receivers
    sm -> r++:notifyActivityRearrangedInSheet(currentSheet, oldPosition, position)
    deactivate r
  end    
  sm -->> Actor

  deactivate sm
end
@enduml
